//
// C++ Interface: kpgviewproppage
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGVIEWPROPPAGE_H
#define KPGVIEWPROPPAGE_H

#include "kpgviewproppagebase.h"

// include files for libpgxx 
#include <pqxx/util.h> 

#include "../kpgaclitem.h"

class KPGView;

/**
View properties

@author Lumir Vanek
*/

class KPGSyntaxHighlighter;

class KPGViewPropPage : public KPGViewPropPageBase
{
Q_OBJECT
public:
    KPGViewPropPage(QWidget *, KPGView * );
    ~KPGViewPropPage();
    
    void setACL(const QString &);
    
protected:
  /** Syntax highlighter for view definition */
  KPGSyntaxHighlighter *m_pSyntaxHighlighter;
  
  KPGView * m_pView;
  KPGAclItemList m_listOfAclItems;
          
protected slots:

    // Changes syntax highlighting colors.
    void slotSqlEditorSettingsChanged();

    virtual void slotTablePropDblClicked(int, int, int, const QPoint &);  
		virtual void slotAclListViewClicked(QListViewItem *, const QPoint &, int);
    virtual void slotUpdateACL();
    
signals:
		void sigSearchObject(const pqxx::oid);
    void sigRunWizard(const QString &);
};

#endif
