//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "kpgconnectioninthread.h"

// include files for Qt
#include <qdatetime.h>

// include files for KDE
#include <kdebug.h>
#include <klocale.h>
#include <kmessagebox.h>
#include <kapplication.h>

#include "DbObjects/kpgtreeitem.h"


KPGConnectionInThread::KPGConnectionInThread()
 : QThread()
{
  m_pConnection = 0;
}

KPGConnectionInThread::~KPGConnectionInThread()
{
  if(m_pConnection)
  {
    if(m_pConnection->is_open() == true)
      m_pConnection->disconnect();
 
    delete m_pConnection;
  }
}

bool KPGConnectionInThread::connectToServer(const QString &strConnectString)
{
  try
  {
    m_pConnection = new KPGConnection(strConnectString);
  }
  catch (const std::exception &e)
  {
    kdError() << "Failed to open database " << e.what() << endl;
    KMessageBox::sorry(0, e.what());
    return false;
  }

  if(m_pConnection->is_open() == false)
  {
    kdError() << "Failed to open database" << endl;
    KMessageBox::sorry(0, "Failed to open connection: " + strConnectString);
    return false;
  }
  
  return true;
}

void KPGConnectionInThread::disconnectFromServer()
{
  if(m_pConnection)
  {
    if(m_pConnection->is_open() == true)
      m_pConnection->disconnect();
 
    delete m_pConnection;
    m_pConnection = 0;
  }
}

// Call it when connection thread is terminated
void KPGConnectionInThread::leaveConnection()
{
  if(m_pConnection)
  {
    m_pConnection = 0;
  }
}

void KPGConnectionInThread::run()
{
  PKGQueryResultEvent *pQueryResultEvent = new PKGQueryResultEvent(m_strEncoderName, m_pConnection);
  
  // run query on selected database
  try
  {
    QTime t;
    t.start();
    pQueryResultEvent->result() = m_pConnection->runQuery(m_strSQL, m_eTransType);
    pQueryResultEvent->setExecutionMiliseconds(t.elapsed());
  }
  catch (const std::exception &e)
  {
     pQueryResultEvent->setError(e.what());
  } 
  
  QApplication::postEvent(m_pEventReceiver, pQueryResultEvent);
}
