//
// C++ Interface: kpgsqlqueryresultchildview
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGSQLQUERYRESULTCHILDVIEW_H
#define KPGSQLQUERYRESULTCHILDVIEW_H

#include <kmdichildview.h>

// include files for KDE
#include <kurl.h>

class KPGSqlQueryResultWindow;
class KPoGreView;

/**
MDI child view for query/result window.
Also have ability to load/save SQL script

	@author Lumir Vanek <lvanek@users.sourceforge.net>
*/
class KPGSqlQueryResultChildView : public KMdiChildView
{
	Q_OBJECT
public:
    KPGSqlQueryResultChildView(KPoGreView *);
    ~KPGSqlQueryResultChildView();

	KPGSqlQueryResultWindow * getSqlQueryResultWindow() const { return m_pSqlQueryResultWindow; }

	// Initializes the document generally */
    bool newDocument();
    
	// Loads the document by filename and format 
    bool openDocument(const KURL& url, const char *format=0);

    // saves the document under filename and format.
    bool saveDocument(const KURL& url, const char *format=0);
    
    // Returns the KURL of the document */
    const KURL& URL() const;
    
    // Return true, if SQL script is modified
    const bool isModified() const;

	// Return true, if window can be closed
	bool requestClose();
	
protected:
	KURL m_urlSqlFile;

private:
	KPGSqlQueryResultWindow *m_pSqlQueryResultWindow;
	KPoGreView* m_pPoGreView;
};

#endif
